Index: dnspython-1.12.0/dns/rdata.py
===================================================================
--- dnspython-1.12.0.orig/dns/rdata.py
+++ dnspython-1.12.0/dns/rdata.py
@@ -25,7 +25,10 @@ default is 'dns.rdtypes'.  Changing this
 chunk of hexstring that _hexify() produces before whitespace occurs.
 @type _hex_chunk: int"""
 
-import cStringIO
+from io import BytesIO
+import base64
+import binascii
+import struct
 
 import dns.exception
 import dns.name
@@ -33,10 +36,14 @@ import dns.rdataclass
 import dns.rdatatype
 import dns.tokenizer
 import dns.wiredata
+from ._compat import xrange, string_types, text_type, binary_type
+
+from ._compat import xcmp
 
 _hex_chunksize = 32
 
-def _hexify(data, chunksize=None):
+
+def _hexify(data, chunksize=_hex_chunksize):
     """Convert a binary string into its hex encoding, broken up into chunks
     of I{chunksize} characters separated by a space.
 
@@ -46,22 +53,15 @@ def _hexify(data, chunksize=None):
     @rtype: string
     """
 
-    if chunksize is None:
-        chunksize = _hex_chunksize
-    hex = data.encode('hex_codec')
-    l = len(hex)
-    if l > chunksize:
-        chunks = []
-        i = 0
-        while i < l:
-            chunks.append(hex[i : i + chunksize])
-            i += chunksize
-        hex = ' '.join(chunks)
-    return hex
+    line = binascii.hexlify(data)
+    return b' '.join([line[i:i + chunksize]
+                      for i
+                      in range(0, len(line), chunksize)]).decode()
 
 _base64_chunksize = 32
 
-def _base64ify(data, chunksize=None):
+
+def _base64ify(data, chunksize=_base64_chunksize):
     """Convert a binary string into its base64 encoding, broken up into chunks
     of I{chunksize} characters separated by a space.
 
@@ -72,24 +72,16 @@ def _base64ify(data, chunksize=None):
     @rtype: string
     """
 
-    if chunksize is None:
-        chunksize = _base64_chunksize
-    b64 = data.encode('base64_codec')
-    b64 = b64.replace('\n', '')
-    l = len(b64)
-    if l > chunksize:
-        chunks = []
-        i = 0
-        while i < l:
-            chunks.append(b64[i : i + chunksize])
-            i += chunksize
-        b64 = ' '.join(chunks)
-    return b64
+    line = base64.b64encode(data)
+    return b' '.join([line[i:i + chunksize]
+                      for i
+                      in range(0, len(line), chunksize)]).decode()
 
 __escaped = {
-    '"' : True,
-    '\\' : True,
-    }
+    '"': True,
+    '\\': True,
+}
+
 
 def _escapify(qstring):
     """Escape the characters in a quoted string which need it.
@@ -100,16 +92,23 @@ def _escapify(qstring):
     @rtype: string
     """
 
+    if isinstance(qstring, text_type):
+        qstring = qstring.encode()
+    if not isinstance(qstring, bytearray):
+        qstring = bytearray(qstring)
+
     text = ''
     for c in qstring:
-        if c in __escaped:
-            text += '\\' + c
-        elif ord(c) >= 0x20 and ord(c) < 0x7F:
-            text += c
+        packed = struct.pack('!B', c).decode()
+        if packed in __escaped:
+            text += '\\' + packed
+        elif c >= 0x20 and c < 0x7F:
+            text += packed
         else:
-            text += '\\%03d' % ord(c)
+            text += '\\%03d' % c
     return text
 
+
 def _truncate_bitmap(what):
     """Determine the index of greatest byte that isn't all zeros, and
     return the bitmap that contains all the bytes less than that index.
@@ -120,11 +119,13 @@ def _truncate_bitmap(what):
     """
 
     for i in xrange(len(what) - 1, -1, -1):
-        if what[i] != '\x00':
+        if what[i] != 0:
             break
-    return ''.join(what[0 : i + 1])
+    return what[0: i + 1]
+
 
 class Rdata(object):
+
     """Base class for all DNS rdata types.
     """
 
@@ -167,17 +168,17 @@ class Rdata(object):
         """
         raise NotImplementedError
 
-    def to_wire(self, file, compress = None, origin = None):
+    def to_wire(self, file, compress=None, origin=None):
         """Convert an rdata to wire format.
         @rtype: string
         """
 
         raise NotImplementedError
 
-    def to_digestable(self, origin = None):
+    def to_digestable(self, origin=None):
         """Convert rdata to a format suitable for digesting in hashes.  This
         is also the DNSSEC canonical form."""
-        f = cStringIO.StringIO()
+        f = BytesIO()
         self.to_wire(f, None, origin)
         return f.getvalue()
 
@@ -264,11 +265,11 @@ class Rdata(object):
         # We specifiy an arbitrary origin of '.' when doing the
         # comparison, since the rdata may have relative names and we
         # can't convert a relative name to wire without an origin.
-        b1 = cStringIO.StringIO()
+        b1 = BytesIO()
         self.to_wire(b1, None, dns.name.root)
-        b2 = cStringIO.StringIO()
+        b2 = BytesIO()
         other.to_wire(b2, None, dns.name.root)
-        return cmp(b1.getvalue(), b2.getvalue())
+        return xcmp(b1.getvalue(), b2.getvalue())
 
     def from_text(cls, rdclass, rdtype, tok, origin = None, relativize = True):
         """Build an rdata object from text format.
@@ -288,9 +289,8 @@ class Rdata(object):
 
         raise NotImplementedError
 
-    from_text = classmethod(from_text)
-
-    def from_wire(cls, rdclass, rdtype, wire, current, rdlen, origin = None):
+    @classmethod
+    def from_wire(cls, rdclass, rdtype, wire, current, rdlen, origin=None):
         """Build an rdata object from wire format
 
         @param rdclass: The rdata class
@@ -310,9 +310,7 @@ class Rdata(object):
 
         raise NotImplementedError
 
-    from_wire = classmethod(from_wire)
-
-    def choose_relativity(self, origin = None, relativize = True):
+    def choose_relativity(self, origin=None, relativize=True):
         """Convert any domain names in the rdata to the specified
         relativization.
         """
@@ -321,6 +319,7 @@ class Rdata(object):
 
 
 class GenericRdata(Rdata):
+
     """Generate Rdata Class
 
     This class is used for rdata types for which we have no better
@@ -336,6 +335,7 @@ class GenericRdata(Rdata):
     def to_text(self, origin=None, relativize=True, **kw):
         return r'\# %d ' % len(self.data) + _hexify(self.data)
 
+    @classmethod
     def from_text(cls, rdclass, rdtype, tok, origin = None, relativize = True):
         token = tok.get()
         if not token.is_identifier() or token.value != '\#':
@@ -346,25 +346,22 @@ class GenericRdata(Rdata):
             token = tok.get()
             if token.is_eol_or_eof():
                 break
-            chunks.append(token.value)
-        hex = ''.join(chunks)
-        data = hex.decode('hex_codec')
+            chunks.append(token.value.encode())
+        hex = b''.join(chunks)
+        data = binascii.unhexlify(hex)
         if len(data) != length:
             raise dns.exception.SyntaxError('generic rdata hex data has wrong length')
         return cls(rdclass, rdtype, data)
 
-    from_text = classmethod(from_text)
-
     def to_wire(self, file, compress = None, origin = None):
         file.write(self.data)
 
+    @classmethod
     def from_wire(cls, rdclass, rdtype, wire, current, rdlen, origin = None):
         return cls(rdclass, rdtype, wire[current : current + rdlen])
 
-    from_wire = classmethod(from_wire)
-
     def _cmp(self, other):
-        return cmp(self.data, other.data)
+        return xcmp(self.data, other.data)
 
 _rdata_modules = {}
 _module_prefix = 'dns.rdtypes'
@@ -402,7 +399,8 @@ def get_rdata_class(rdclass, rdtype):
         cls = GenericRdata
     return cls
 
-def from_text(rdclass, rdtype, tok, origin = None, relativize = True):
+
+def from_text(rdclass, rdtype, tok, origin=None, relativize=True):
     """Build an rdata object from text format.
 
     This function attempts to dynamically load a class which
@@ -428,7 +426,7 @@ def from_text(rdclass, rdtype, tok, orig
     @type relativize: bool
     @rtype: dns.rdata.Rdata instance"""
 
-    if isinstance(tok, str):
+    if isinstance(tok, (text_type, binary_type)):
         tok = dns.tokenizer.Tokenizer(tok)
     cls = get_rdata_class(rdclass, rdtype)
     if cls != GenericRdata:
@@ -448,7 +446,8 @@ def from_text(rdclass, rdtype, tok, orig
                              origin)
     return cls.from_text(rdclass, rdtype, tok, origin, relativize)
 
-def from_wire(rdclass, rdtype, wire, current, rdlen, origin = None):
+
+def from_wire(rdclass, rdtype, wire, current, rdlen, origin=None):
     """Build an rdata object from wire format
 
     This function attempts to dynamically load a class which
Index: dnspython-1.12.0/dns/rdataclass.py
===================================================================
--- dnspython-1.12.0.orig/dns/rdataclass.py
+++ dnspython-1.12.0/dns/rdataclass.py
@@ -47,7 +47,7 @@ _by_text = {
 # cannot make any mistakes (e.g. omissions, cut-and-paste errors) that
 # would cause the mapping not to be true inverse.
 
-_by_value = dict([(y, x) for x, y in _by_text.iteritems()])
+_by_value = dict((y, x) for x, y in _by_text.items())
 
 # Now that we've built the inverse map, we can add class aliases to
 # the _by_text mapping.
@@ -81,13 +81,14 @@ def from_text(text):
     value = _by_text.get(text.upper())
     if value is None:
         match = _unknown_class_pattern.match(text)
-        if match == None:
+        if match is None:
             raise UnknownRdataclass
         value = int(match.group(1))
         if value < 0 or value > 65535:
             raise ValueError("class must be between >= 0 and <= 65535")
     return value
 
+
 def to_text(value):
     """Convert a DNS rdata class to text.
     @param value: the rdata class value
@@ -100,15 +101,16 @@ def to_text(value):
         raise ValueError("class must be between >= 0 and <= 65535")
     text = _by_value.get(value)
     if text is None:
-        text = 'CLASS' + `value`
+        text = 'CLASS' + repr(value)
     return text
 
+
 def is_metaclass(rdclass):
     """True if the class is a metaclass.
     @param rdclass: the rdata class
     @type rdclass: int
     @rtype: bool"""
 
-    if _metaclasses.has_key(rdclass):
+    if rdclass in _metaclasses:
         return True
     return False
Index: dnspython-1.12.0/dns/rdataset.py
===================================================================
--- dnspython-1.12.0.orig/dns/rdataset.py
+++ dnspython-1.12.0/dns/rdataset.py
@@ -16,7 +16,7 @@
 """DNS rdatasets (an rdataset is a set of rdatas of a given type and class)"""
 
 import random
-import StringIO
+from io import StringIO
 import struct
 
 import dns.exception
@@ -24,6 +24,7 @@ import dns.rdatatype
 import dns.rdataclass
 import dns.rdata
 import dns.set
+from ._compat import string_types
 
 # define SimpleSet here for backwards compatibility
 SimpleSet = dns.set.Set
@@ -110,7 +111,7 @@ class Rdataset(dns.set.Set):
         #
         if self.rdclass != rd.rdclass or self.rdtype != rd.rdtype:
             raise IncompatibleTypes
-        if not ttl is None:
+        if ttl is not None:
             self.update_ttl(ttl)
         if self.rdtype == dns.rdatatype.RRSIG or \
            self.rdtype == dns.rdatatype.SIG:
@@ -185,15 +186,15 @@ class Rdataset(dns.set.Set):
         @type origin: dns.name.Name object
         @param relativize: True if names should names be relativized
         @type relativize: bool"""
-        if not name is None:
+        if name is not None:
             name = name.choose_relativity(origin, relativize)
             ntext = str(name)
             pad = ' '
         else:
             ntext = ''
             pad = ''
-        s = StringIO.StringIO()
-        if not override_rdclass is None:
+        s = StringIO()
+        if override_rdclass is not None:
             rdclass = override_rdclass
         else:
             rdclass = self.rdclass
@@ -203,15 +204,16 @@ class Rdataset(dns.set.Set):
             # some dynamic updates, so we don't need to print out the TTL
             # (which is meaningless anyway).
             #
-            print >> s, '%s%s%s %s' % (ntext, pad,
-                                       dns.rdataclass.to_text(rdclass),
-                                       dns.rdatatype.to_text(self.rdtype))
+            s.write(u'%s%s%s %s\n' % (ntext, pad,
+                                      dns.rdataclass.to_text(rdclass),
+                                      dns.rdatatype.to_text(self.rdtype)))
         else:
             for rd in self:
-                print >> s, '%s%s%d %s %s %s' % \
-                      (ntext, pad, self.ttl, dns.rdataclass.to_text(rdclass),
-                       dns.rdatatype.to_text(self.rdtype),
-                       rd.to_text(origin=origin, relativize=relativize, **kw))
+                s.write(u'%s%s%d %s %s %s\n' %
+                        (ntext, pad, self.ttl, dns.rdataclass.to_text(rdclass),
+                         dns.rdatatype.to_text(self.rdtype),
+                         rd.to_text(origin=origin, relativize=relativize,
+                         **kw)))
         #
         # We strip off the final \n for the caller's convenience in printing
         #
@@ -233,8 +235,8 @@ class Rdataset(dns.set.Set):
         @rtype: int
         """
 
-        if not override_rdclass is None:
-            rdclass =  override_rdclass
+        if override_rdclass is not None:
+            rdclass = override_rdclass
             want_shuffle = False
         else:
             rdclass = self.rdclass
@@ -274,6 +276,7 @@ class Rdataset(dns.set.Set):
             return True
         return False
 
+
 def from_text_list(rdclass, rdtype, ttl, text_rdatas):
     """Create an rdataset with the specified class, type, and TTL, and with
     the specified list of rdatas in text format.
@@ -281,9 +284,9 @@ def from_text_list(rdclass, rdtype, ttl,
     @rtype: dns.rdataset.Rdataset object
     """
 
-    if isinstance(rdclass, (str, unicode)):
+    if isinstance(rdclass, string_types):
         rdclass = dns.rdataclass.from_text(rdclass)
-    if isinstance(rdtype, (str, unicode)):
+    if isinstance(rdtype, string_types):
         rdtype = dns.rdatatype.from_text(rdtype)
     r = Rdataset(rdclass, rdtype)
     r.update_ttl(ttl)
@@ -292,6 +295,7 @@ def from_text_list(rdclass, rdtype, ttl,
         r.add(rd)
     return r
 
+
 def from_text(rdclass, rdtype, ttl, *text_rdatas):
     """Create an rdataset with the specified class, type, and TTL, and with
     the specified rdatas in text format.
@@ -301,6 +305,7 @@ def from_text(rdclass, rdtype, ttl, *tex
 
     return from_text_list(rdclass, rdtype, ttl, text_rdatas)
 
+
 def from_rdata_list(ttl, rdatas):
     """Create an rdataset with the specified TTL, and with
     the specified list of rdata objects.
@@ -315,10 +320,10 @@ def from_rdata_list(ttl, rdatas):
         if r is None:
             r = Rdataset(rd.rdclass, rd.rdtype)
             r.update_ttl(ttl)
-            first_time = False
         r.add(rd)
     return r
 
+
 def from_rdata(ttl, *rdatas):
     """Create an rdataset with the specified TTL, and with
     the specified rdata objects.
Index: dnspython-1.12.0/dns/rdatatype.py
===================================================================
--- dnspython-1.12.0.orig/dns/rdatatype.py
+++ dnspython-1.12.0/dns/rdatatype.py
@@ -160,7 +160,7 @@ _by_text = {
 # cannot make any mistakes (e.g. omissions, cut-and-paste errors) that
 # would cause the mapping not to be true inverse.
 
-_by_value = dict([(y, x) for x, y in _by_text.iteritems()])
+_by_value = dict((y, x) for x, y in _by_text.items())
 
 
 _metatypes = {
@@ -192,13 +192,14 @@ def from_text(text):
     value = _by_text.get(text.upper())
     if value is None:
         match = _unknown_type_pattern.match(text)
-        if match == None:
+        if match is None:
             raise UnknownRdatatype
         value = int(match.group(1))
         if value < 0 or value > 65535:
             raise ValueError("type must be between >= 0 and <= 65535")
     return value
 
+
 def to_text(value):
     """Convert a DNS rdata type to text.
     @param value: the rdata type value
@@ -210,25 +211,27 @@ def to_text(value):
         raise ValueError("type must be between >= 0 and <= 65535")
     text = _by_value.get(value)
     if text is None:
-        text = 'TYPE' + `value`
+        text = 'TYPE' + repr(value)
     return text
 
+
 def is_metatype(rdtype):
     """True if the type is a metatype.
     @param rdtype: the type
     @type rdtype: int
     @rtype: bool"""
 
-    if rdtype >= TKEY and rdtype <= ANY or _metatypes.has_key(rdtype):
+    if rdtype >= TKEY and rdtype <= ANY or rdtype in _metatypes:
         return True
     return False
 
+
 def is_singleton(rdtype):
     """True if the type is a singleton.
     @param rdtype: the type
     @type rdtype: int
     @rtype: bool"""
 
-    if _singletons.has_key(rdtype):
+    if rdtype in _singletons:
         return True
     return False
Index: dnspython-1.12.0/dns/rdtypes/ANY/CERT.py
===================================================================
--- dnspython-1.12.0.orig/dns/rdtypes/ANY/CERT.py
+++ dnspython-1.12.0/dns/rdtypes/ANY/CERT.py
@@ -13,43 +13,49 @@
 # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT
 # OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 
-import cStringIO
 import struct
+import base64
 
 import dns.exception
 import dns.dnssec
 import dns.rdata
 import dns.tokenizer
+from io import BytesIO
+from dns._compat import xcmp
 
 _ctype_by_value = {
-    1 : 'PKIX',
-    2 : 'SPKI',
-    3 : 'PGP',
-    253 : 'URI',
-    254 : 'OID',
-    }
+    1: 'PKIX',
+    2: 'SPKI',
+    3: 'PGP',
+    253: 'URI',
+    254: 'OID',
+}
 
 _ctype_by_name = {
-    'PKIX' : 1,
-    'SPKI' : 2,
-    'PGP' : 3,
-    'URI' : 253,
-    'OID' : 254,
-    }
+    'PKIX': 1,
+    'SPKI': 2,
+    'PGP': 3,
+    'URI': 253,
+    'OID': 254,
+}
+
 
 def _ctype_from_text(what):
     v = _ctype_by_name.get(what)
-    if not v is None:
+    if v is not None:
         return v
     return int(what)
 
+
 def _ctype_to_text(what):
     v = _ctype_by_value.get(what)
-    if not v is None:
+    if v is not None:
         return v
     return str(what)
 
+
 class CERT(dns.rdata.Rdata):
+
     """CERT record
 
     @ivar certificate_type: certificate type
@@ -78,7 +84,8 @@ class CERT(dns.rdata.Rdata):
                                 dns.dnssec.algorithm_to_text(self.algorithm),
                                 dns.rdata._base64ify(self.certificate))
 
-    def from_text(cls, rdclass, rdtype, tok, origin = None, relativize = True):
+    @classmethod
+    def from_text(cls, rdclass, rdtype, tok, origin=None, relativize=True):
         certificate_type = _ctype_from_text(tok.get_string())
         key_tag = tok.get_uint16()
         algorithm = dns.dnssec.algorithm_from_text(tok.get_string())
@@ -91,35 +98,32 @@ class CERT(dns.rdata.Rdata):
                 break
             if not t.is_identifier():
                 raise dns.exception.SyntaxError
-            chunks.append(t.value)
-        b64 = ''.join(chunks)
-        certificate = b64.decode('base64_codec')
+            chunks.append(t.value.encode())
+        b64 = b''.join(chunks)
+        certificate = base64.b64decode(b64)
         return cls(rdclass, rdtype, certificate_type, key_tag,
                    algorithm, certificate)
 
-    from_text = classmethod(from_text)
-
-    def to_wire(self, file, compress = None, origin = None):
+    def to_wire(self, file, compress=None, origin=None):
         prefix = struct.pack("!HHB", self.certificate_type, self.key_tag,
                              self.algorithm)
         file.write(prefix)
         file.write(self.certificate)
 
-    def from_wire(cls, rdclass, rdtype, wire, current, rdlen, origin = None):
-        prefix = wire[current : current + 5].unwrap()
+    @classmethod
+    def from_wire(cls, rdclass, rdtype, wire, current, rdlen, origin=None):
+        prefix = wire[current: current + 5].unwrap()
         current += 5
         rdlen -= 5
         if rdlen < 0:
             raise dns.exception.FormError
         (certificate_type, key_tag, algorithm) = struct.unpack("!HHB", prefix)
-        certificate = wire[current : current + rdlen].unwrap()
+        certificate = wire[current: current + rdlen].unwrap()
         return cls(rdclass, rdtype, certificate_type, key_tag, algorithm,
                    certificate)
 
-    from_wire = classmethod(from_wire)
-
     def _cmp(self, other):
-        f = cStringIO.StringIO()
+        f = BytesIO()
         self.to_wire(f)
         wire1 = f.getvalue()
         f.seek(0)
@@ -128,4 +132,4 @@ class CERT(dns.rdata.Rdata):
         wire2 = f.getvalue()
         f.close()
 
-        return cmp(wire1, wire2)
+        return xcmp(wire1, wire2)
Index: dnspython-1.12.0/dns/rdtypes/ANY/DNSKEY.py
===================================================================
--- dnspython-1.12.0.orig/dns/rdtypes/ANY/DNSKEY.py
+++ dnspython-1.12.0/dns/rdtypes/ANY/DNSKEY.py
@@ -20,6 +20,9 @@ import dns.exception
 import dns.dnssec
 import dns.rdata
 
+import base64
+from dns._compat import xcmp
+
 
 # flag constants
 SEP = 0x0001
@@ -35,7 +38,7 @@ _flag_by_text = {
 # We construct the inverse mapping programmatically to ensure that we
 # cannot make any mistakes (e.g. omissions, cut-and-paste errors) that
 # would cause the mapping not to be true inverse.
-_flag_by_value = dict([(y, x) for x, y in _flag_by_text.iteritems()])
+_flag_by_value = dict([(y, x) for x, y in _flag_by_text.items()])
 
 
 def flags_to_text_set(flags):
@@ -93,6 +96,7 @@ class DNSKEY(dns.rdata.Rdata):
         return '%d %d %d %s' % (self.flags, self.protocol, self.algorithm,
                                 dns.rdata._base64ify(self.key))
 
+    @classmethod
     def from_text(cls, rdclass, rdtype, tok, origin = None, relativize = True):
         flags = tok.get_uint16()
         protocol = tok.get_uint8()
@@ -104,18 +108,17 @@ class DNSKEY(dns.rdata.Rdata):
                 break
             if not t.is_identifier():
                 raise dns.exception.SyntaxError
-            chunks.append(t.value)
-        b64 = ''.join(chunks)
-        key = b64.decode('base64_codec')
+            chunks.append(t.value.encode())
+        b64 = b''.join(chunks)
+        key = base64.b64decode(b64)
         return cls(rdclass, rdtype, flags, protocol, algorithm, key)
 
-    from_text = classmethod(from_text)
-
     def to_wire(self, file, compress = None, origin = None):
         header = struct.pack("!HBB", self.flags, self.protocol, self.algorithm)
         file.write(header)
         file.write(self.key)
 
+    @classmethod
     def from_wire(cls, rdclass, rdtype, wire, current, rdlen, origin = None):
         if rdlen < 4:
             raise dns.exception.FormError
@@ -126,14 +129,12 @@ class DNSKEY(dns.rdata.Rdata):
         return cls(rdclass, rdtype, header[0], header[1], header[2],
                    key)
 
-    from_wire = classmethod(from_wire)
-
     def _cmp(self, other):
         hs = struct.pack("!HBB", self.flags, self.protocol, self.algorithm)
         ho = struct.pack("!HBB", other.flags, other.protocol, other.algorithm)
-        v = cmp(hs, ho)
+        v = xcmp(hs, ho)
         if v == 0:
-            v = cmp(self.key, other.key)
+            v = xcmp(self.key, other.key)
         return v
 
     def flags_to_text_set(self):
Index: dnspython-1.12.0/dns/rdtypes/ANY/GPOS.py
===================================================================
--- dnspython-1.12.0.orig/dns/rdtypes/ANY/GPOS.py
+++ dnspython-1.12.0/dns/rdtypes/ANY/GPOS.py
@@ -13,24 +13,37 @@
 # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT
 # OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 
+import struct
+
 import dns.exception
 import dns.rdata
 import dns.tokenizer
+from dns._compat import long, text_type
+from dns._compat import xcmp
+
 
 def _validate_float_string(what):
-    if what[0] == '-' or what[0] == '+':
+    if what[0] == b'-'[0] or what[0] == b'+'[0]:
         what = what[1:]
     if what.isdigit():
         return
-    (left, right) = what.split('.')
-    if left == '' and right == '':
+    (left, right) = what.split(b'.')
+    if left == b'' and right == b'':
         raise dns.exception.FormError
-    if not left == '' and not left.isdigit():
+    if not left == b'' and not left.decode().isdigit():
         raise dns.exception.FormError
-    if not right == '' and not right.isdigit():
+    if not right == b'' and not right.decode().isdigit():
         raise dns.exception.FormError
 
+
+def _sanitize(value):
+    if isinstance(value, text_type):
+        return value.encode()
+    return value
+
+
 class GPOS(dns.rdata.Rdata):
+
     """GPOS record
 
     @ivar latitude: latitude
@@ -57,6 +70,9 @@ class GPOS(dns.rdata.Rdata):
            isinstance(altitude, int) or \
            isinstance(altitude, long):
             altitude = str(altitude)
+        latitude = _sanitize(latitude)
+        longitude = _sanitize(longitude)
+        altitude = _sanitize(altitude)
         _validate_float_string(latitude)
         _validate_float_string(longitude)
         _validate_float_string(altitude)
@@ -65,8 +81,11 @@ class GPOS(dns.rdata.Rdata):
         self.altitude = altitude
 
     def to_text(self, origin=None, relativize=True, **kw):
-        return '%s %s %s' % (self.latitude, self.longitude, self.altitude)
+        return '%s %s %s' % (self.latitude.decode(),
+                             self.longitude.decode(),
+                             self.altitude.decode())
 
+    @classmethod
     def from_text(cls, rdclass, rdtype, tok, origin = None, relativize = True):
         latitude = tok.get_string()
         longitude = tok.get_string()
@@ -74,27 +93,23 @@ class GPOS(dns.rdata.Rdata):
         tok.get_eol()
         return cls(rdclass, rdtype, latitude, longitude, altitude)
 
-    from_text = classmethod(from_text)
-
     def to_wire(self, file, compress = None, origin = None):
         l = len(self.latitude)
         assert l < 256
-        byte = chr(l)
-        file.write(byte)
+        file.write(struct.pack('!B', l))
         file.write(self.latitude)
         l = len(self.longitude)
         assert l < 256
-        byte = chr(l)
-        file.write(byte)
+        file.write(struct.pack('!B', l))
         file.write(self.longitude)
         l = len(self.altitude)
         assert l < 256
-        byte = chr(l)
-        file.write(byte)
+        file.write(struct.pack('!B', l))
         file.write(self.altitude)
 
+    @classmethod
     def from_wire(cls, rdclass, rdtype, wire, current, rdlen, origin = None):
-        l = ord(wire[current])
+        l = wire[current]
         current += 1
         rdlen -= 1
         if l > rdlen:
@@ -102,7 +117,7 @@ class GPOS(dns.rdata.Rdata):
         latitude = wire[current : current + l].unwrap()
         current += l
         rdlen -= l
-        l = ord(wire[current])
+        l = wire[current]
         current += 1
         rdlen -= 1
         if l > rdlen:
@@ -110,7 +125,7 @@ class GPOS(dns.rdata.Rdata):
         longitude = wire[current : current + l].unwrap()
         current += l
         rdlen -= l
-        l = ord(wire[current])
+        l = wire[current]
         current += 1
         rdlen -= 1
         if l != rdlen:
@@ -118,14 +133,12 @@ class GPOS(dns.rdata.Rdata):
         altitude = wire[current : current + l].unwrap()
         return cls(rdclass, rdtype, latitude, longitude, altitude)
 
-    from_wire = classmethod(from_wire)
-
     def _cmp(self, other):
-        v = cmp(self.latitude, other.latitude)
+        v = xcmp(self.latitude, other.latitude)
         if v == 0:
-            v = cmp(self.longitude, other.longitude)
+            v = xcmp(self.longitude, other.longitude)
             if v == 0:
-                v = cmp(self.altitude, other.altitude)
+                v = xcmp(self.altitude, other.altitude)
         return v
 
     def _get_float_latitude(self):
Index: dnspython-1.12.0/dns/rdtypes/ANY/HINFO.py
===================================================================
--- dnspython-1.12.0.orig/dns/rdtypes/ANY/HINFO.py
+++ dnspython-1.12.0/dns/rdtypes/ANY/HINFO.py
@@ -13,11 +13,17 @@
 # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT
 # OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 
+import struct
+
 import dns.exception
 import dns.rdata
 import dns.tokenizer
+from dns._compat import text_type
+from dns._compat import xcmp
+
 
 class HINFO(dns.rdata.Rdata):
+
     """HINFO record
 
     @ivar cpu: the CPU type
@@ -30,35 +36,39 @@ class HINFO(dns.rdata.Rdata):
 
     def __init__(self, rdclass, rdtype, cpu, os):
         super(HINFO, self).__init__(rdclass, rdtype)
-        self.cpu = cpu
-        self.os = os
+        if isinstance(cpu, text_type):
+            self.cpu = cpu.encode()
+        else:
+            self.cpu = cpu
+        if isinstance(os, text_type):
+            self.os = os.encode()
+        else:
+            self.os = os
 
     def to_text(self, origin=None, relativize=True, **kw):
         return '"%s" "%s"' % (dns.rdata._escapify(self.cpu),
                               dns.rdata._escapify(self.os))
 
+    @classmethod
     def from_text(cls, rdclass, rdtype, tok, origin = None, relativize = True):
         cpu = tok.get_string()
         os = tok.get_string()
         tok.get_eol()
         return cls(rdclass, rdtype, cpu, os)
 
-    from_text = classmethod(from_text)
-
     def to_wire(self, file, compress = None, origin = None):
         l = len(self.cpu)
         assert l < 256
-        byte = chr(l)
-        file.write(byte)
+        file.write(struct.pack('!B', l))
         file.write(self.cpu)
         l = len(self.os)
         assert l < 256
-        byte = chr(l)
-        file.write(byte)
+        file.write(struct.pack('!B', l))
         file.write(self.os)
 
+    @classmethod
     def from_wire(cls, rdclass, rdtype, wire, current, rdlen, origin = None):
-        l = ord(wire[current])
+        l = wire[current]
         current += 1
         rdlen -= 1
         if l > rdlen:
@@ -66,7 +76,7 @@ class HINFO(dns.rdata.Rdata):
         cpu = wire[current : current + l].unwrap()
         current += l
         rdlen -= l
-        l = ord(wire[current])
+        l = wire[current]
         current += 1
         rdlen -= 1
         if l != rdlen:
@@ -74,10 +84,8 @@ class HINFO(dns.rdata.Rdata):
         os = wire[current : current + l].unwrap()
         return cls(rdclass, rdtype, cpu, os)
 
-    from_wire = classmethod(from_wire)
-
     def _cmp(self, other):
-        v = cmp(self.cpu, other.cpu)
+        v = xcmp(self.cpu, other.cpu)
         if v == 0:
-            v = cmp(self.os, other.os)
+            v = xcmp(self.os, other.os)
         return v
